dizhi8255_a    equ 230h       ; 定义8255_a为地址230h
dizhi8255_b    equ 231h       ; 定义8255_b为地址231h
dizhi8255_c    equ 232h       ; 定义8255_c为地址232h
dizhi8255_kongzhi    equ 233h       ; 定义8255_kongzhi为地址233h
dizhi8253_0    equ 210h       ; 定义8253_0为地址210h
dizhi8253_1    equ 211h       ; 定义8253_1为地址211h
dizhi8253_kongzhi    equ 213h       ; 定义8253_kongzhi为地址213h
dizhi8259_0    equ 200h       ; 定义8259_0为地址200h
dizhi8259_1    equ 201h       ; 定义8259_1为地址201h

; 数据段定义
data        segment
    count1  dw  0               ; 中断计数
    portcl  db  0ch,14h,21h,22h,0ffh   ; 红绿灯状态字
    input   db  ?               ; 读取电位器数据
    buf db  0               ; 电相
data        ends

; 栈段定义
st_ssg      segment stack
    db  256 dup(?)
st_ssg      ends

; 代码段定义
code    segment
    assume  cs:code, ds:data, ss:st_ssg
start:
    cli                       ; 关中断
    mov ax, data              ; 将数据段地址赋值给ax寄存器
    mov ds, ax                ; 将ax寄存器的值赋给ds寄存器

    ; 初始化8259
    mov dx, dizhi8259_0           ; 将dizhi8259_0的地址赋值给dx寄存器
    mov al, 00010011B         ; 初始化控制字1
    out dx, al
    mov dx, dizhi8259_1           ; 将dizhi8259_1的地址赋值给dx寄存器
   ; mov al, 00001000B         ; 初始化控制字2
    ;out dx, al
   ; mov al, 00000001B         ; 初始化控制字4
   ; out dx, al

    ; 定义中断向量
    push    ds
    mov ax, 0
    mov ds, ax
    lea ax, cs:int_proc      ; 将int_proc的入口地址赋值给ax寄存器
    mov si, 08h              ; MIR0类型码08h
    add si, si
    add si, si  
    mov ds:[si], ax          ; 将ax寄存器的值存储在中断向量表中的ip位置
    push    cs
    pop ax
    mov ds:[si+2], ax        ; 将ax寄存器的值存储在中断向量表中的cs位置
    pop ds
    in  al, dx
    and al, 11111110b
    out dx, al

    ; 初始化8253分频器
    mov ax, 0
    mov al, 00110110b
    mov dx, dizhi8253_kongzhi
    out dx, al
    mov ax, 10000
    mov dx, dizhi8253_0
    out dx, al
    mov al, ah
    out dx, al

    ; 初始化8255芯片
    mov dx, dizhi8255_kongzhi
    mov al, 10001000b
    out dx, al

    mov buf, 33h
    sti                     ; 开中断

    ; 数据转换
lop1:
     call light ;调用交通灯显示程序
     jmp lop1

;-----------------------------------交通灯显示--------------------------
light:
    call    digital

    mov dx, dizhi8255_b
lvdeng1:cmp count1, 500     ; 判断是否到5s输出主干道通行（绿灯）
    ja  huangdeng1
    mov al, portcl
    out dx, al
    jmp ok
huangdeng1:cmp count1, 700     ; 判断是否到2s主干道黄灯状态
    ja  lvdeng2
    mov al, portcl[1]
    out dx, al
    jmp ok
lvdeng2:cmp count1, 1000        ; 判断是否到3s输出从干道通行（黄灯）
    ja  huangdeng2
    mov al, portcl[2]
    out dx, al
    jmp ok
huangdeng2:cmp count1, 1200        ; 判断是否到2s从干道黄灯状态
    ja  finish
    mov al, portcl[3]
    out dx, al
    jmp ok
finish: mov count1, 0       ; 一次循环结束后置count1为0
ok: call    digital
    jmp lop1

;---------------------------倒计时数码管显示-----------------------------
digital proc
begin:
    mov dx, dizhi8255_a
zhu5:   cmp count1, 100 ;主干道
    ja  zhu4
    mov al, 6Dh
    out dx, al
    jmp exit
zhu4:   cmp count1, 200
    ja  zhu3
    mov al, 66h
    out dx, al
    jmp exit
zhu3:   cmp count1, 300
    ja  zhu2
    mov al, 4Fh
    out dx, al
    jmp exit
zhu2:   cmp count1, 400
    ja  zhu1
    mov al, 5Bh
    out dx, al
    jmp exit
zhu1:   cmp count1, 500
    ja  zhu22
    mov al, 06h
    out dx, al
    jmp exit
zhu22:  cmp count1, 600  ;黄灯
    ja  zhu11
    mov al, 5Bh
    out dx, al
    jmp exit
zhu11:  cmp count1, 700
    ja  zhi3
    mov al, 06h
    out dx, al
    jmp exit
zhi3:   cmp count1, 800
    ja  zhi2
    mov al, 4Fh
    out dx, al
    jmp exit
zhi2:   cmp count1, 900
    ja  zhi1
    mov al, 5Bh
    out dx, al
    jmp exit
zhi1:   cmp count1, 1000
    ja  zhi22
    mov al, 06h
    out dx, al
    jmp exit
zhi22:  cmp count1, 1100
    ja  zhi11
    mov al, 5Bh
    out dx, al
    jmp exit
zhi11:  cmp count1, 1200
    ja  exit
    mov al, 06h
    out dx, al
exit:   ret
digital endp



;-----------------------------中断服务程序---------------------------------
int_proc    proc    far
    push    ax
    push    dx
int1:   inc count1
    mov al, 20h
    mov dx, dizhi8259_0
    out dx, al
    pop dx
    pop ax
    sti
    iret
int_proc    endp

code    ends
end start